import java.io.*;
import java.awt.*;
import java.util.*;

public class Vm{
	public int ip;		// Befehlszhler
	public long ax;		// Akku
	public String 	cmd[];	// Befehle
	public int 			arg[];		// Argumente
	public long 		mem[];	// Speicher
	public Hashtable ALU;
		
	
	public static void main(String args[]) {
		Vm vm = new Vm();
		while(true)
			vm.los();
	}
		
	
	public Vm() {
		ip=1;
		ax=0;
		BufferedReader in; 
		try {
			Frame f=new Frame();
			FileDialog fd = new FileDialog(f);
			fd.setMode(FileDialog.LOAD);
			fd.setFile("*.asm");
			fd.show();
			String dateiname = fd.getFile();
			String pfad = fd.getDirectory();
			f.dispose();

			in = new BufferedReader(new FileReader(pfad+dateiname));
			cmd = new String[1000];
			arg = new int[1000];
			while(true){
				StringTokenizer st = new StringTokenizer(in.readLine());
				int line = Integer.parseInt(st.nextToken());
				cmd[line] = st.nextToken();
				arg[line] = Integer.parseInt(st.nextToken());

			}
		} catch (Throwable e) {}
		mem = new long[1000];
		ALU = new Hashtable();
		ALU.put("LDA",new LDA());
		ALU.put("LDK",new LDK());
		ALU.put("STA",new STA());
		ALU.put("ADD",new ADD());
		ALU.put("SUB",new SUB());
		ALU.put("JMP",new JMP());
		ALU.put("JGE",new JGE());
		ALU.put("JEZ",new JEZ());
		ALU.put("JGZ",new JGZ());
		ALU.put("INP",new INP());
		ALU.put("OUT",new OUT());
		ALU.put("PRT",new PRT());
		ALU.put("HLT",new HLT());
	}
	
	public void los(){
		Instruction inst = (Instruction)ALU.get(cmd[ip]);
		inst.exec(this);
	}
}

interface Instruction{
	public void exec(Vm vm);
}

class LDA implements Instruction {
	public void exec(Vm vm) {
		vm.ax = vm.mem[vm.arg[vm.ip]];
		vm.ip++;
	}
}
class LDK implements Instruction {
	public void exec(Vm vm) {
		vm.ax = vm.arg[vm.ip];
		vm.ip++;
	}
}
class STA implements Instruction {
	public void exec(Vm vm) {
		vm.mem[vm.arg[vm.ip]] = vm.ax;
		vm.ip++;
	}
}
class ADD implements Instruction {
	public void exec(Vm vm) {
		vm.ax += vm.mem[vm.arg[vm.ip]];
		vm.ip++;
	}
}
class SUB implements Instruction {
	public void exec(Vm vm) {
		vm.ax -= vm.mem[vm.arg[vm.ip]];
		vm.ip++;
	}
}
class JMP implements Instruction {
	public void exec(Vm vm) {
		vm.ip = vm.arg[vm.ip];
	}
}
class JGE implements Instruction {
	public void exec(Vm vm) {
		if(vm.ax >= 0) vm.ip = vm.arg[vm.ip];
		else vm.ip++;
	}
}
class JEZ implements Instruction {
	public void exec(Vm vm) {
		if(vm.ax == 0) vm.ip = vm.arg[vm.ip];
		else vm.ip++;
	}
}
class JGZ implements Instruction {
	public void exec(Vm vm) {
		if(vm.ax > 0) vm.ip = vm.arg[vm.ip];
		else vm.ip++;
	}
}
class INP implements Instruction {
	public void exec(Vm vm) {
		System.out.println("Wert fr " + vm.arg[vm.ip] + ":");
		String answ = "";
		try {
			answ = new BufferedReader(new InputStreamReader(System.in)).readLine();
		} catch (Throwable t) { System.exit(1);}
			
		vm.mem[vm.arg[vm.ip]] = Integer.parseInt(answ);
		vm.ip++;
	}
}
class OUT implements Instruction {
	public void exec(Vm vm) {
		System.out.println(vm.mem[vm.arg[vm.ip]]+"\n");
		vm.ip++;
	}
}
class PRT implements Instruction {
	public void exec(Vm vm) {
		System.out.println(vm.ax + "\n");
		vm.ip++;
	}
}
class HLT implements Instruction {
	public void exec(Vm vm) {
		vm.ip = -1;
		System.exit(0);
	}
}

	

		
		
	